/*----- PROTECTED REGION ID(Standa8SMC4Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: Standa8SMC4Class.cpp,v 1.4 2016-11-11 09:39:26 graziano Exp $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/8smc4/src/Standa8SMC4Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Standa8SMC4Class.cpp
//
// description : C++ source for the Standa8SMC4Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Standa8SMC4 once per process.
//
// project :     Standa 8SMC4
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.4 $
// $Date: 2016-11-11 09:39:26 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Standa8SMC4Class.h>

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class.cpp

//-------------------------------------------------------------------
/**
 *	Create Standa8SMC4Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Standa8SMC4_class(const char *name) {
		return Standa8SMC4_ns::Standa8SMC4Class::init(name);
	}
}

namespace Standa8SMC4_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Standa8SMC4Class *Standa8SMC4Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Standa8SMC4Class::Standa8SMC4Class(string &s)
 * description : 	constructor for the Standa8SMC4Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Standa8SMC4Class::Standa8SMC4Class(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering Standa8SMC4Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Standa8SMC4Class::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::constructor

	cout2 << "Leaving Standa8SMC4Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Standa8SMC4Class::~Standa8SMC4Class()
 * description : 	destructor for the Standa8SMC4Class
 */
//--------------------------------------------------------
Standa8SMC4Class::~Standa8SMC4Class()
{
	/*----- PROTECTED REGION ID(Standa8SMC4Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Standa8SMC4Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Standa8SMC4Class *Standa8SMC4Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Standa8SMC4Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Standa8SMC4Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Standa8SMC4Class *Standa8SMC4Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ForwardClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ForwardClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "ForwardClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Standa8SMC4 *>(device))->forward(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		BackwardClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *BackwardClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "BackwardClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Standa8SMC4 *>(device))->backward(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<Standa8SMC4 *>(device))->stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOFFClass::execute(): arrived" << endl;
	((static_cast<Standa8SMC4 *>(device))->motor_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorONClass::execute(): arrived" << endl;
	((static_cast<Standa8SMC4 *>(device))->motor_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorSTANDBYClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorSTANDBYClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorSTANDBYClass::execute(): arrived" << endl;
	((static_cast<Standa8SMC4 *>(device))->motor_standby());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GoHomeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GoHomeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GoHomeClass::execute(): arrived" << endl;
	((static_cast<Standa8SMC4 *>(device))->go_home());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetHomeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetHomeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetHomeClass::execute(): arrived" << endl;
	((static_cast<Standa8SMC4 *>(device))->set_home());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GoToPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GoToPositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GoToPositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Standa8SMC4 *>(device))->go_to_position(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		FindEdgeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *FindEdgeClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "FindEdgeClass::execute(): arrived" << endl;
	Tango::DevLong argin;
	extract(in_any, argin);
	((static_cast<Standa8SMC4 *>(device))->find_edge(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetHomeValueClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetHomeValueClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SetHomeValueClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Standa8SMC4 *>(device))->set_home_value(argin));
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Standa8SMC4Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Standa8SMC4Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Standa8SMC4Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Standa8SMC4Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "AxisNumber";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisForwardLimit";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisBackwardLimit";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Serialdevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Serial_timeout";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Wr_sleep";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Th_sleep";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PositionRatio";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Current_position";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Limit_switch_polarity";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SerialNumber";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "StageName";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Standa8SMC4Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Standa 8SMC4");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Standa8SMC4");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Standa8SMC4Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Standa8SMC4Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Standa8SMC4(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Standa8SMC4 *dev = static_cast<Standa8SMC4 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Standa8SMC4Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Standa8SMC4Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Standa8SMC4Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::attribute_factory_before
	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib();
	Tango::UserDefaultAttrProp	position_prop;
	//	description	not set for Position
	//	label	not set for Position
	//	unit	not set for Position
	//	standard_unit	not set for Position
	//	display_unit	not set for Position
	//	format	not set for Position
	//	max_value	not set for Position
	//	min_value	not set for Position
	//	max_alarm	not set for Position
	//	min_alarm	not set for Position
	//	max_warning	not set for Position
	//	min_warning	not set for Position
	//	delta_t	not set for Position
	//	delta_val	not set for Position
	
	position->set_default_properties(position_prop);
	//	Not Polled
	position->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(position);

	//	Attribute : Acceleration
	AccelerationAttrib	*acceleration = new AccelerationAttrib();
	Tango::UserDefaultAttrProp	acceleration_prop;
	//	description	not set for Acceleration
	//	label	not set for Acceleration
	//	unit	not set for Acceleration
	//	standard_unit	not set for Acceleration
	//	display_unit	not set for Acceleration
	//	format	not set for Acceleration
	//	max_value	not set for Acceleration
	//	min_value	not set for Acceleration
	//	max_alarm	not set for Acceleration
	//	min_alarm	not set for Acceleration
	//	max_warning	not set for Acceleration
	//	min_warning	not set for Acceleration
	//	delta_t	not set for Acceleration
	//	delta_val	not set for Acceleration
	
	acceleration->set_default_properties(acceleration_prop);
	//	Not Polled
	acceleration->set_disp_level(Tango::OPERATOR);
	acceleration->set_memorized();
	acceleration->set_memorized_init(true);
	att_list.push_back(acceleration);

	//	Attribute : Accuracy
	AccuracyAttrib	*accuracy = new AccuracyAttrib();
	Tango::UserDefaultAttrProp	accuracy_prop;
	//	description	not set for Accuracy
	//	label	not set for Accuracy
	//	unit	not set for Accuracy
	//	standard_unit	not set for Accuracy
	//	display_unit	not set for Accuracy
	//	format	not set for Accuracy
	//	max_value	not set for Accuracy
	//	min_value	not set for Accuracy
	//	max_alarm	not set for Accuracy
	//	min_alarm	not set for Accuracy
	//	max_warning	not set for Accuracy
	//	min_warning	not set for Accuracy
	//	delta_t	not set for Accuracy
	//	delta_val	not set for Accuracy
	
	accuracy->set_default_properties(accuracy_prop);
	//	Not Polled
	accuracy->set_disp_level(Tango::OPERATOR);
	accuracy->set_memorized();
	accuracy->set_memorized_init(true);
	att_list.push_back(accuracy);

	//	Attribute : Position_home
	Position_homeAttrib	*position_home = new Position_homeAttrib();
	Tango::UserDefaultAttrProp	position_home_prop;
	//	description	not set for Position_home
	//	label	not set for Position_home
	//	unit	not set for Position_home
	//	standard_unit	not set for Position_home
	//	display_unit	not set for Position_home
	//	format	not set for Position_home
	//	max_value	not set for Position_home
	//	min_value	not set for Position_home
	//	max_alarm	not set for Position_home
	//	min_alarm	not set for Position_home
	//	max_warning	not set for Position_home
	//	min_warning	not set for Position_home
	//	delta_t	not set for Position_home
	//	delta_val	not set for Position_home
	
	position_home->set_default_properties(position_home_prop);
	//	Not Polled
	position_home->set_disp_level(Tango::OPERATOR);
	position_home->set_memorized();
	position_home->set_memorized_init(true);
	att_list.push_back(position_home);

	//	Attribute : Stat
	StatAttrib	*stat = new StatAttrib();
	Tango::UserDefaultAttrProp	stat_prop;
	stat_prop.set_description("0=standby\n1=moving\n2=resetting to left\n3=resetting to right");
	//	label	not set for Stat
	//	unit	not set for Stat
	//	standard_unit	not set for Stat
	//	display_unit	not set for Stat
	//	format	not set for Stat
	//	max_value	not set for Stat
	//	min_value	not set for Stat
	//	max_alarm	not set for Stat
	//	min_alarm	not set for Stat
	//	max_warning	not set for Stat
	//	min_warning	not set for Stat
	//	delta_t	not set for Stat
	//	delta_val	not set for Stat
	
	stat->set_default_properties(stat_prop);
	//	Not Polled
	stat->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(stat);

	//	Attribute : EdgesStatus
	EdgesStatusAttrib	*edgesstatus = new EdgesStatusAttrib();
	Tango::UserDefaultAttrProp	edgesstatus_prop;
	//	description	not set for EdgesStatus
	//	label	not set for EdgesStatus
	//	unit	not set for EdgesStatus
	//	standard_unit	not set for EdgesStatus
	//	display_unit	not set for EdgesStatus
	//	format	not set for EdgesStatus
	//	max_value	not set for EdgesStatus
	//	min_value	not set for EdgesStatus
	//	max_alarm	not set for EdgesStatus
	//	min_alarm	not set for EdgesStatus
	//	max_warning	not set for EdgesStatus
	//	min_warning	not set for EdgesStatus
	//	delta_t	not set for EdgesStatus
	//	delta_val	not set for EdgesStatus
	
	edgesstatus->set_default_properties(edgesstatus_prop);
	//	Not Polled
	edgesstatus->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(edgesstatus);

	//	Attribute : HomingConfig
	HomingConfigAttrib	*homingconfig = new HomingConfigAttrib();
	Tango::UserDefaultAttrProp	homingconfig_prop;
	//	description	not set for HomingConfig
	//	label	not set for HomingConfig
	//	unit	not set for HomingConfig
	//	standard_unit	not set for HomingConfig
	//	display_unit	not set for HomingConfig
	//	format	not set for HomingConfig
	//	max_value	not set for HomingConfig
	//	min_value	not set for HomingConfig
	//	max_alarm	not set for HomingConfig
	//	min_alarm	not set for HomingConfig
	//	max_warning	not set for HomingConfig
	//	min_warning	not set for HomingConfig
	//	delta_t	not set for HomingConfig
	//	delta_val	not set for HomingConfig
	
	homingconfig->set_default_properties(homingconfig_prop);
	//	Not Polled
	homingconfig->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(homingconfig);

	//	Attribute : Serialdevice
	SerialdeviceAttrib	*serialdevice = new SerialdeviceAttrib();
	Tango::UserDefaultAttrProp	serialdevice_prop;
	//	description	not set for Serialdevice
	//	label	not set for Serialdevice
	//	unit	not set for Serialdevice
	//	standard_unit	not set for Serialdevice
	//	display_unit	not set for Serialdevice
	//	format	not set for Serialdevice
	//	max_value	not set for Serialdevice
	//	min_value	not set for Serialdevice
	//	max_alarm	not set for Serialdevice
	//	min_alarm	not set for Serialdevice
	//	max_warning	not set for Serialdevice
	//	min_warning	not set for Serialdevice
	//	delta_t	not set for Serialdevice
	//	delta_val	not set for Serialdevice
	
	serialdevice->set_default_properties(serialdevice_prop);
	//	Not Polled
	serialdevice->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(serialdevice);

	//	Attribute : SerialNumber
	SerialNumberAttrib	*serialnumber = new SerialNumberAttrib();
	Tango::UserDefaultAttrProp	serialnumber_prop;
	//	description	not set for SerialNumber
	//	label	not set for SerialNumber
	//	unit	not set for SerialNumber
	//	standard_unit	not set for SerialNumber
	//	display_unit	not set for SerialNumber
	serialnumber_prop.set_format("0x%x");
	//	max_value	not set for SerialNumber
	//	min_value	not set for SerialNumber
	//	max_alarm	not set for SerialNumber
	//	min_alarm	not set for SerialNumber
	//	max_warning	not set for SerialNumber
	//	min_warning	not set for SerialNumber
	//	delta_t	not set for SerialNumber
	//	delta_val	not set for SerialNumber
	
	serialnumber->set_default_properties(serialnumber_prop);
	//	Not Polled
	serialnumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(serialnumber);

	//	Attribute : StageName
	StageNameAttrib	*stagename = new StageNameAttrib();
	Tango::UserDefaultAttrProp	stagename_prop;
	//	description	not set for StageName
	//	label	not set for StageName
	//	unit	not set for StageName
	//	standard_unit	not set for StageName
	//	display_unit	not set for StageName
	//	format	not set for StageName
	//	max_value	not set for StageName
	//	min_value	not set for StageName
	//	max_alarm	not set for StageName
	//	min_alarm	not set for StageName
	//	max_warning	not set for StageName
	//	min_warning	not set for StageName
	//	delta_t	not set for StageName
	//	delta_val	not set for StageName
	
	stagename->set_default_properties(stagename_prop);
	//	Not Polled
	stagename->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(stagename);

	//	Attribute : Speed
	SpeedAttrib	*speed = new SpeedAttrib();
	Tango::UserDefaultAttrProp	speed_prop;
	speed_prop.set_description("double[0]: min speed\ndouble[1]: max speed");
	//	label	not set for Speed
	//	unit	not set for Speed
	//	standard_unit	not set for Speed
	//	display_unit	not set for Speed
	//	format	not set for Speed
	//	max_value	not set for Speed
	//	min_value	not set for Speed
	//	max_alarm	not set for Speed
	//	min_alarm	not set for Speed
	//	max_warning	not set for Speed
	//	min_warning	not set for Speed
	//	delta_t	not set for Speed
	//	delta_val	not set for Speed
	
	speed->set_default_properties(speed_prop);
	//	Not Polled
	speed->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(speed);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Standa8SMC4Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void Standa8SMC4Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(Standa8SMC4Class::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::pipe_factory_before
	/*----- PROTECTED REGION ID(Standa8SMC4Class::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Standa8SMC4Class::command_factory()
{
	/*----- PROTECTED REGION ID(Standa8SMC4Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::command_factory_before


	//	Command Forward
	ForwardClass	*pForwardCmd =
		new ForwardClass("Forward",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pForwardCmd);

	//	Command Backward
	BackwardClass	*pBackwardCmd =
		new BackwardClass("Backward",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pBackwardCmd);

	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	//	Command MotorOFF
	MotorOFFClass	*pMotorOFFCmd =
		new MotorOFFClass("MotorOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pMotorOFFCmd);

	//	Command MotorON
	MotorONClass	*pMotorONCmd =
		new MotorONClass("MotorON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pMotorONCmd);

	//	Command MotorSTANDBY
	MotorSTANDBYClass	*pMotorSTANDBYCmd =
		new MotorSTANDBYClass("MotorSTANDBY",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pMotorSTANDBYCmd);

	//	Command GoHome
	GoHomeClass	*pGoHomeCmd =
		new GoHomeClass("GoHome",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGoHomeCmd);

	//	Command SetHome
	SetHomeClass	*pSetHomeCmd =
		new SetHomeClass("SetHome",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSetHomeCmd);

	//	Command GoToPosition
	GoToPositionClass	*pGoToPositionCmd =
		new GoToPositionClass("GoToPosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"absolute position in user units",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGoToPositionCmd);

	//	Command FindEdge
	FindEdgeClass	*pFindEdgeCmd =
		new FindEdgeClass("FindEdge",
			Tango::DEV_LONG, Tango::DEV_VOID,
			"0=find left limit switch 1=find right limit switch",
			"",
			Tango::OPERATOR);
	command_list.push_back(pFindEdgeCmd);

	//	Command SetHomeValue
	SetHomeValueClass	*pSetHomeValueCmd =
		new SetHomeValueClass("SetHomeValue",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"Actual Position",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSetHomeValueCmd);

	/*----- PROTECTED REGION ID(Standa8SMC4Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Standa8SMC4Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void Standa8SMC4Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Standa8SMC4Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Standa8SMC4Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Standa8SMC4Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Standa8SMC4 *dev = static_cast<Standa8SMC4 *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Standa8SMC4Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4Class::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Standa8SMC4Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Standa8SMC4Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4Class::Additional Methods
} //	namespace
